'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var reactUnityWebgl = require('react-unity-webgl');
var react = require('@sei-js/react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __awaiter(thisArg, _arguments, P, generator) {
  function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
  return new (P || (P = Promise))(function (resolve, reject) {
      function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
      function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
      function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
      step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}

function __generator(thisArg, body) {
  var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
  return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
  function verb(n) { return function (v) { return step([n, v]); }; }
  function step(op) {
      if (f) throw new TypeError("Generator is already executing.");
      while (g && (g = 0, op[0] && (_ = 0)), _) try {
          if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
          if (y = 0, t) op = [op[0] & 2, t.value];
          switch (op[0]) {
              case 0: case 1: t = op; break;
              case 4: _.label++; return { value: op[1], done: false };
              case 5: _.label++; y = op[1]; op = [0]; continue;
              case 7: op = _.ops.pop(); _.trys.pop(); continue;
              default:
                  if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                  if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                  if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                  if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                  if (t[2]) _.ops.pop();
                  _.trys.pop(); continue;
          }
          op = body.call(thisArg, _);
      } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
      if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
  }
}

function __spreadArray(to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
      if (ar || !(i in from)) {
          if (!ar) ar = Array.prototype.slice.call(from, 0, i);
          ar[i] = from[i];
      }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
}

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
  var e = new Error(message);
  return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

// boilerplate code
var SeiAgent = function (_a) {
    var eventQueue = _a.eventQueue, setEventQueue = _a.setEventQueue, _b = _a.timeoutMs, timeoutMs = _b === void 0 ? 30000 : _b, sendMessage = _a.sendMessage, isLoaded = _a.isLoaded;
    var _c = react.useWallet(), connectedWallet = _c.connectedWallet, accounts = _c.accounts; _c.chainId;
    var _d = React.useState(null), timeoutHandler = _d[0], setTimeoutHandler = _d[1];
    var _e = react.useSelectWallet(), openModal = _e.openModal, closeModal = _e.closeModal;
    var _f = React.useState(null), resolvePromise = _f[0], setResolvePromise = _f[1];
    var queryClient = react.useCosmWasmClient().cosmWasmClient;
    var signingClient = react.useSigningCosmWasmClient().signingCosmWasmClient;
    var sendMessageToUnity = React.useCallback(function (payload) {
        try {
            sendMessage('SeiSdkManager', 'WebResponse', payload);
        }
        catch (error) {
            console.error('Error sending message to Unity:', error);
        }
    }, [isLoaded, sendMessage]);
    var onLoginCallback = React.useCallback(function (requestId, accountAddress, error) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            sendMessageToUnity(JSON.stringify({
                Id: requestId,
                Response: !error
                    ? JSON.stringify({
                        WalletAddress: accountAddress,
                    })
                    : '',
                Error: error ? error === null || error === void 0 ? void 0 : error.message : '',
            }));
            return [2 /*return*/];
        });
    }); }, [sendMessageToUnity]);
    var onExecuteCallback = React.useCallback(function (requestId, response, error) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            sendMessageToUnity(JSON.stringify({
                Id: requestId,
                Response: !error ? JSON.stringify(response) : '',
                Error: error ? error === null || error === void 0 ? void 0 : error.message : '',
            }));
            return [2 /*return*/];
        });
    }); }, [sendMessageToUnity]);
    var onQueryCallback = React.useCallback(function (requestId, response, error) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            sendMessageToUnity(JSON.stringify({
                Id: requestId,
                Response: !error ? JSON.stringify(response) : '',
                Error: error ? error === null || error === void 0 ? void 0 : error.message : '',
            }));
            return [2 /*return*/];
        });
    }); }, [sendMessageToUnity]);
    var processEventQueue = React.useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        var event_1, walletAddress, error_1, response, error_2, error_3;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!(eventQueue.length > 0)) return [3 /*break*/, 16];
                    event_1 = eventQueue.shift();
                    if (!(event_1 && event_1.name === 'OnLogin')) return [3 /*break*/, 5];
                    if (connectedWallet) {
                        onLoginCallback(event_1.id, (_a = accounts[0]) === null || _a === void 0 ? void 0 : _a.address, 'Already logged in');
                        return [3 /*break*/, 0];
                    }
                    openModal();
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, new Promise(function (resolve, reject) {
                            var handler = setTimeout(function () {
                                setEventQueue([]);
                                closeModal();
                                reject(new Error('Timeout'));
                            }, timeoutMs);
                            setTimeoutHandler(handler);
                            setResolvePromise(function () { return resolve; });
                        })];
                case 2:
                    walletAddress = _b.sent();
                    onLoginCallback(event_1.id, walletAddress, '');
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _b.sent();
                    console.error('Error on login:', error_1);
                    onLoginCallback(event_1.id, '', (error_1 === null || error_1 === void 0 ? void 0 : error_1.message) || 'Unknown');
                    return [3 /*break*/, 4];
                case 4: return [3 /*break*/, 15];
                case 5:
                    if (!(event_1 && event_1.name === 'OnLogout')) return [3 /*break*/, 6];
                    // TODO: implement logout
                    return [3 /*break*/, 0];
                case 6:
                    if (!(event_1 && event_1.name === 'OnQuery')) return [3 /*break*/, 11];
                    _b.label = 7;
                case 7:
                    _b.trys.push([7, 9, , 10]);
                    return [4 /*yield*/, (queryClient === null || queryClient === void 0 ? void 0 : queryClient.queryContractSmart(event_1.data.ContractAddress, event_1.data.Query))];
                case 8:
                    response = _b.sent();
                    onQueryCallback(event_1.id, response, '');
                    return [3 /*break*/, 10];
                case 9:
                    error_2 = _b.sent();
                    console.error('Error on query:', error_2);
                    onQueryCallback(event_1.id, '', (error_2 === null || error_2 === void 0 ? void 0 : error_2.message) || 'Unknown');
                    return [3 /*break*/, 10];
                case 10: return [3 /*break*/, 15];
                case 11:
                    if (!(event_1 && event_1.name === 'OnExecute')) return [3 /*break*/, 15];
                    if (!signingClient) {
                        console.error('signingClient is not ready');
                        onExecuteCallback(event_1.id, '', 'Signing client unavailable');
                        return [3 /*break*/, 0];
                    }
                    _b.label = 12;
                case 12:
                    _b.trys.push([12, 14, , 15]);
                    return [4 /*yield*/, signingClient.execute(event_1.data.SenderAddress, event_1.data.ContractAddress, event_1.data.Message, event_1.data.Fee)];
                case 13:
                    _b.sent();
                    onExecuteCallback(event_1.id, '', '');
                    return [3 /*break*/, 15];
                case 14:
                    error_3 = _b.sent();
                    console.error('Error on execute:', error_3);
                    onExecuteCallback(event_1.id, '', (error_3 === null || error_3 === void 0 ? void 0 : error_3.message) || 'Unknown');
                    return [3 /*break*/, 15];
                case 15: return [3 /*break*/, 0];
                case 16:
                    setEventQueue([]);
                    return [2 /*return*/];
            }
        });
    }); }, [onLoginCallback, onExecuteCallback, onQueryCallback]);
    React.useEffect(function () {
        var _a;
        if (!!connectedWallet && !!resolvePromise) {
            timeoutHandler && clearTimeout(timeoutHandler);
            setTimeoutHandler(null);
            resolvePromise(((_a = accounts[0]) === null || _a === void 0 ? void 0 : _a.address) || '');
        }
    }, [resolvePromise, connectedWallet]);
    React.useEffect(function () {
        if (eventQueue.length > 0) {
            processEventQueue();
        }
    }, [eventQueue]);
    return React__default["default"].createElement("div", null);
};

var Peacemaker = function (_a) {
    var loaderUrl = _a.loaderUrl, // example value: 'unity/Build/Build.loader.js'
    dataUrl = _a.dataUrl, // example value: 'unity/Build/Build.data'
    frameworkUrl = _a.frameworkUrl, // example value: 'unity/Build/Build.framework.js'
    codeUrl = _a.codeUrl, // example value: 'unity/Build/Build.wasm'
    onUnityError = _a.onUnityError, onUnityLoad = _a.onUnityLoad, _b = _a.timeoutMs, timeoutMs = _b === void 0 ? 30000 : _b, _c = _a.width, width = _c === void 0 ? '800px' : _c, _d = _a.height, height = _d === void 0 ? '600px' : _d;
    var _e = reactUnityWebgl.useUnityContext({
        loaderUrl: loaderUrl,
        dataUrl: dataUrl,
        frameworkUrl: frameworkUrl,
        codeUrl: codeUrl,
    }), unityProvider = _e.unityProvider, isLoaded = _e.isLoaded, addEventListener = _e.addEventListener, sendMessage = _e.sendMessage, removeEventListener = _e.removeEventListener;
    var _f = React.useState(''), errorMessage = _f[0], setErrorMessage = _f[1];
    var _g = React.useState(''), chainId = _g[0], setChainId = _g[1];
    var _h = React.useState(''), restUrl = _h[0], setRestUrl = _h[1];
    var _j = React.useState(''), rpcUrl = _j[0], setRpcUrl = _j[1];
    var _k = React.useState([]), walletList = _k[0], setWalletList = _k[1];
    var _l = React.useState([]), eventQueue = _l[0], setEventQueue = _l[1];
    React.useEffect(function () {
        var handleError = function () {
            var parameters = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                parameters[_i] = arguments[_i];
            }
            var message = parameters[0];
            console.error('Error occured in Unity:', message);
            setErrorMessage(message);
        };
        addEventListener('error', handleError);
        return function () {
            removeEventListener('error', handleError);
        };
    }, []);
    React.useEffect(function () {
        addEventListener('OnLogin', handleSeiLoginRequest);
        addEventListener('OnExecute', handleSeiExecuteRequest);
        addEventListener('OnQuery', handleSeiQueryRequest);
        return function () {
            removeEventListener('OnLogin', handleSeiLoginRequest);
        };
    }, []);
    React.useEffect(function () {
        if (onUnityLoad) {
            onUnityLoad();
        }
    }, [isLoaded]);
    React.useEffect(function () {
        if (onUnityError) {
            onUnityError(errorMessage);
        }
    }, [errorMessage]);
    var unwrapParameters = React.useCallback(function (parameters) {
        var stringData = parameters[0];
        if (typeof stringData !== 'string') {
            throw new Error('Expected string data, got:' + typeof stringData);
        }
        var payload = JSON.parse(stringData);
        if (!payload) {
            throw new Error('Expected non empty payload');
        }
        if (!payload.Id || !payload.Request) {
            throw new Error('Expected Id and Request in payload');
        }
        return payload;
    }, []);
    var handleSeiLoginRequest = React.useCallback(function () {
        var parameters = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            parameters[_i] = arguments[_i];
        }
        var payload = unwrapParameters(parameters);
        var id = payload.Id;
        var request = JSON.parse(payload.Request);
        if (!request.ChainId || !request.RestUrl || !request.RpcUrl) {
            throw new Error('Expected ChainId, RestUrl and RpcUrl in Login Request');
        }
        setChainId(request.ChainId);
        setRestUrl(request.RestUrl);
        setRpcUrl(request.RpcUrl);
        setWalletList(request.WalletList || ['compass']);
        var newEvent = {
            id: id,
            name: 'OnLogin',
            data: request,
            // callback: onLoginCallback,
        };
        var newEventQueue = __spreadArray(__spreadArray([], eventQueue, true), [newEvent], false);
        setEventQueue(newEventQueue);
    }, []);
    var handleSeiExecuteRequest = React.useCallback(function () {
        var parameters = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            parameters[_i] = arguments[_i];
        }
        console.log('OnLogin Parameters:', parameters);
        var payload = unwrapParameters(parameters);
        var id = payload.Id;
        var request = JSON.parse(payload.Request);
        if (!request.SenderAddress || !request.ContractAddress || !request.Message || !request.Fee) {
            throw new Error('Expected SenderAddress, ContractAddress, Message and Fee in Execute Request');
        }
        var newEvent = {
            id: id,
            name: 'OnExecute',
            data: request,
            // callback: onExecuteCallback,
        };
        var newEventQueue = __spreadArray(__spreadArray([], eventQueue, true), [newEvent], false);
        setEventQueue(newEventQueue);
    }, []);
    var handleSeiQueryRequest = React.useCallback(function () {
        var parameters = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            parameters[_i] = arguments[_i];
        }
        var payload = unwrapParameters(parameters);
        var id = payload.Id;
        var request = JSON.parse(payload.Request);
        if (!request.ContractAddress || !request.Query) {
            throw new Error('Expected ContractAddress and Query in Query Request');
        }
        var newEvent = {
            id: id,
            name: 'OnQuery',
            data: request,
            // callback: onQueryCallback,
        };
        var newEventQueue = __spreadArray(__spreadArray([], eventQueue, true), [newEvent], false);
        setEventQueue(newEventQueue);
    }, []);
    return (React__default["default"].createElement("div", null,
        chainId && restUrl && rpcUrl && walletList && (React__default["default"].createElement(react.SeiWalletProvider, { chainConfiguration: {
                chainId: chainId,
                restUrl: restUrl,
                rpcUrl: rpcUrl,
            }, wallets: walletList },
            React__default["default"].createElement(SeiAgent, { sendMessage: sendMessage, isLoaded: isLoaded, eventQueue: eventQueue, setEventQueue: setEventQueue, timeoutMs: timeoutMs }))),
        React__default["default"].createElement(reactUnityWebgl.Unity, { unityProvider: unityProvider, style: { width: width, height: height } })));
};

exports.Peacemaker = Peacemaker;
//# sourceMappingURL=index.js.map
